/*
 * Common OS-independent driver header file for rate selection
 * algorithm of Broadcom 802.11b DCF-only Networking Adapter.
 *
 * Copyright 2005-2006, Broadcom Corporation
 * All Rights Reserved.                
 *                                     
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Broadcom Corporation;   
 * the contents of this file may not be disclosed to third parties, copied
 * or duplicated in any form, in whole or in part, without the prior      
 * written permission of Broadcom Corporation.                            
 *
 *
 * $Id$
 */

#ifndef	_WLC_RATE_SEL_H
#define	_WLC_RATE_SEL_H

/* size of rate_state structure.
 * Note: size different if compiled for 64bit systems
 */
#if defined(_WIN64)
#define WLC_RATE_STATE_LEN	56	/* Size for 64-bit system */
#else
#define WLC_RATE_STATE_LEN	48	/* Size for non-64 bit systems */
#endif /* defined(_WIN64) */

/* initialize per-scb state utilized by rate selection */
extern void wlc_rate_init(void *state, uint8 *rates, uint rate_count,
	uint8 *select_rates, uint *selcet_rate_count,
	bool aburn, uint *clronupd);

/* update per-scb state upon received tx status */
extern void wlc_rate_upd_tx(void *state, uint8 *select_rates, uint selcet_rate_count,
	tx_status_t *txs, uint8 weight, uint16 sfbl, uint16 lfbl, bool aburn);

/* select transmit rate given per-scb state */
extern void wlc_rate_sel(void *state, uint8 *select_rates, uint select_rate_count,
	uint16 *frameid, ratespec_t *rate, ratespec_t *fbrate);

/* dump per-scb state, and per-interface algorithm tunable parameters,
 * upon request, (say by wl)
 */
extern int wlc_rate_dump(void *state, uint8 *select_rates, uint select_rate_count,
	char *buf, int size);

/* set per-interface algorithm tunable parameters, upon request (say
 * by wl), allowing performance tweaks in the field
 */
extern int wlc_rate_ioctl(void *arg);

#endif	/* _WLC_RATE_H */
